package com.ruoyi.bst.lightingNum.service;

import java.util.Arrays;
import java.util.List;
import com.ruoyi.bst.lightingNum.domain.LightingNum;
import com.ruoyi.bst.lightingNum.domain.LightingNumVO;
import com.ruoyi.bst.lightingNum.domain.LightingNumQuery;
import com.ruoyi.bst.lightingNum.domain.dto.GiftLightingNumDTO;
import com.ruoyi.bst.order.domain.OrderQuery;
import com.ruoyi.common.domain.vo.LongIntegerVO;
import org.apache.ibatis.annotations.Param;

import javax.validation.Valid;

/**
 * 爆灯次数列表Service接口
 *
 * @author ruoyi
 * @date 2025-04-26
 */
public interface LightingNumService
{


    /**
     * 查询爆灯次数
     *
     * @param id 爆灯次数主键
     * @return 爆灯次数
     */
    public LightingNumVO selectLightingNumById(Long id, boolean scope);

    default LightingNumVO selectLightingNumById(Long id) {
        return this.selectLightingNumById(id, false);
    }

    /**
     * 查询一个
     * @param query
     * @return
     */
    public LightingNumVO selectOne(LightingNumQuery query);

    /**
     * 查询爆灯次数列表列表
     *
     * @param lightingNum 爆灯次数列表
     * @return 爆灯次数列表集合
     */
    public List<LightingNumVO> selectLightingNumList(LightingNumQuery lightingNum);

    /**
     * 新增爆灯次数列表
     *
     * @param lightingNum 爆灯次数列表
     * @return 结果
     */
    public int insertLightingNum(LightingNum lightingNum);

    /**
     * 修改爆灯次数列表
     *
     * @param lightingNum 爆灯次数列表
     * @return 结果
     */
    public int updateLightingNum(LightingNum lightingNum);

    /**
     * 批量删除爆灯次数列表
     *
     * @param ids 需要删除的爆灯次数列表主键集合
     * @return 结果
     */
    public int deleteLightingNumByIds(Long[] ids);

    /**
     * 删除爆灯次数列表信息
     *
     * @param id 爆灯次数列表主键
     * @return 结果
     */
    public int deleteLightingNumById(Long id);


    public int reduceLightingNumByQuery(@Param("data") LightingNum data,@Param("query")  OrderQuery query);

    int giftLightingNum(@Valid GiftLightingNumDTO dto);

    /**
     * 拼接用户爆灯次数信息
     * @param query
     * @return
     */
    List<LongIntegerVO> assembleLightingNum(LightingNumQuery query);
}
